Reflector: A confidential, reliable, distributed file system
============================================================

Overview
--------

Reflector intends to provide internet data storage similar
to that offered by popular web storage providers, while
allowing users to retain control over their data.

For more information, visit
[https://bitbucket.org/pmalmsten/reflector/wiki/Home](https://bitbucket.org/pmalmsten/reflector/wiki/Home).


Package Summary
---------------

This package contains two executable jars:

* server-demo: This tool simulates a peer which can accept requests to store or retrieve blocks.

* reflector-redis-cli: This tool provides a command line interface for accessing Reflector file system volumes.

All of the required libraries to execute these jars are included in the /lib folder of this package.

Requirements
------------

The executable jars in this package are compatible with Java 1.6+ and have been tested with JDK 1.7 on Linux.

In order to run either provided tool, [Redis](http://redis.io/) must be installed and running on your
local machine and accepting connections at the default port. See the Redis website for installation details
for your environment.

Usage
-----

THIS SOFTWARE IS EXPERIMENTAL - USE AT YOUR OWN RISK
SESSIONS ARE TEMPORARY - YOUR DATA MAY NOT BE PERSISTED

1. Ensure that redis is running on your local machine.

   redis-cli is a convenient way to verify this:

        paul@paul-laptop-ubuntu:~$ redis-cli
        redis 127.0.0.1:6379> PING
        PONG
        redis 127.0.0.1:6379>

2. Start _at least 2_ instances of server-demo in separate shells:

   Server-demo accepts a signal argument: the port number to listen on. This must be unique for each instance.

        paul@paul-laptop-ubuntu:~/Desktop/reflector-package-0.1.0$ java -jar server-demo-0.1.0.jar 10001
        Attemping to connect to Redis @ localhost... OK
        Starting server on localhost:10001... OK
        Publishing address to DHT... OK
        Server ready on port 10001.
        Press q, then ENTER, to quit.

   New shell:

        paul@paul-laptop-ubuntu:~/Desktop/reflector-package-0.1.0$ java -jar server-demo-0.1.0.jar 10002
        Attemping to connect to Redis @ localhost... OK
        Starting server on localhost:10002... OK
        Publishing address to DHT... OK
        Server ready on port 10002.
        Press q, then ENTER, to quit.

3. Start reflector-redis-cli:

        paul@paul-laptop-ubuntu:~/Desktop/reflector-package-0.1.0$ java -jar reflector-redis-cli-0.1.0.jar
        Reflector distributed filesystem
        libreflector version 0.1.0
        CLI version 0.1.0

        Copyright (C) Paul Malmsten, 2013. All rights reserved.

        EXPERIMENTAL - USE AT YOUR OWN RISK
        THIS SESSION IS TEMPORARY - DATA MAY NOT BE PERSISTED

        Run 'help' for a list of available commands.
        Attempting to connect to Redis @ localhost:6379...
        Connected.
        >

4. You may now run commands with the CLI. To prepare and mount a new volume, run the following commands:

        >randVolume
        >mountVolume
        >

   The volume is now ready for use. The commands mkdir, ls, put, and get allow you to interact with a
   mounted volume. Use the 'help' command in the CLI for more information about these commands.


